config/routes.rb
Rails.application.routes.draw do
  

  resources :transactions
  resources :supplies
  resources :products
  resources :distributors
  resources :reports, only: [:index]
  devise_for :users, :path_prefix => 'my', controllers: { sessions: 'users/sessions' }
  resources :users
  get 'users/sign_in' => 'users/sessions#new'

  get '/', to: 'home#index'

  

end

app/controllers/transactions_controller.rb
class TransactionsController < ApplicationController
  before_action :set_transaction, only: [:show, :edit, :update, :destroy]

  # GET /transactions
  # GET /transactions.json
  def index
    @transactions = Transaction.all
  end

  # GET /transactions/1
  # GET /transactions/1.json
  def show
  end

  # GET /transactions/new
  def new
    @transaction = Transaction.new
    @products = Product.order('name asc').all
  end

  # GET /transactions/1/edit
  def edit
  end

  # POST /transactions
  # POST /transactions.json
  def create
    @products = Product.all
    @transaction = Transaction.new(transaction_params)
    @product = Product.find(transaction_params[:product_id])
    @transaction.distributor_id = @product.distributor.id
    total_product = @product.available_product.to_i - @transaction.total.to_i

    total_harga = (@transaction.total.to_i * (@product.sell_amount.to_i + (@product.sell_amount.to_f * @transaction.ppn.to_f))) - @transaction.discount.to_f
    @transaction.total_price = total_harga
    respond_to do |format|
      if @transaction.save && @product.update(available_product: total_product)
        format.html { redirect_to transactions_url, notice: 'Transaction was successfully created.' }
        format.json { render :show, status: :created, location: @transaction }
      else
        format.html { render :new }
        format.json { render json: @transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /transactions/1
  # PATCH/PUT /transactions/1.json
  def update
    respond_to do |format|
      if @transaction.update(transaction_params)
        format.html { redirect_to transactions_url, notice: 'Transaction was successfully updated.' }
        format.json { render :show, status: :ok, location: @transaction }
      else
        format.html { render :edit }
        format.json { render json: @transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /transactions/1
  # DELETE /transactions/1.json
  def destroy
    @transaction.destroy
    respond_to do |format|
      format.html { redirect_to transactions_url, notice: 'Transaction was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_transaction
      @transaction = Transaction.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def transaction_params
      params.require(:transaction).permit(:distributor_id, :product_id, :total, :ppn, :discount, :total_price)
    end
end

app/helpers/transactions_helper.rb
module TransactionsHelper
end

app/views/transactions/_form.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="page-title">
            <span class="title">Input Transaction</span>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                      <%= form_for(@transaction) do |form| %>
                      <% if @transaction.errors.any? %>
                        <div class="alert fresh-color alert-danger" role="alert">
                          <ul>
                            <% @transaction.errors.full_messages.each do |message| %>
                            <li>
                              <strong><%= message %></strong>
                            </li>
                            <% end %>
                          </ul>
                        </div>
                        <% end %>
                        <div class="sub-title">Barang</div>
                        <div>
                          <%= form.select :product_id, options_for_select(@products.map{ |c| ["#{c.name} - #{c.size} - #{c.type_product}", c.id] }, selected_key = form.object.product_id), {}, {:class => "form-control"} %>
                        </div>
                        <div for="name" class="sub-title">Total Unit</div>
                        <div>
                            <%= form.number_field :total, class: 'form-control', placeholder: 'total', :required => true %>
                        </div>
                        <div for="name" class="sub-title">PPN</div>
                        <div>
                            <%= form.text_field :ppn, class: 'form-control', placeholder: 'PPN' %>
                        </div>
                        <div for="name" class="sub-title">discount</div>
                        <div>
                            <%= form.number_field :discount, class: 'form-control', placeholder: 'discount' %>
                        </div>
                        <%= link_to 'Back', supplies_path, class: "btn btn-sm btn-default" %>
                        <button type="submit" class="btn btn-sm btn-info">Submit</button>
                      <% end %>
                    </div>
                </div>
            </div>
        </div>
    </div>

app/views/transactions/edit.html.erb
<h1>Editing Transaction</h1>

<%= render 'form' %>

<%= link_to 'Show', @transaction %> |
<%= link_to 'Back', transactions_path %>

app/views/transactions/index.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <div class="card-title">
                        <div class="title">Transaksi Keluar</div>
                        </div>
                        <div class="pull-right card-action">
                          <%= button_to "Input Transaksi", new_transaction_path, class: 'btn btn-info', method: 'get' %>
                        </div>
                    </div>
                    <div class="card-body">
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th bgcolor="#9adbf9">Nama Barang</th>
                                    <th bgcolor="#9adbf9">Jenis Barang</th>
                                    <th bgcolor="#9adbf9">Ukuran Barang</th>
                                    <th bgcolor="#9adbf9">Total Unit</th>
                                    <th bgcolor="#9adbf9">PPN</th>
                                    <th bgcolor="#9adbf9">Diskon</th>
                                    <th bgcolor="#9adbf9">Total Harga</th>
                                    <th bgcolor="#9adbf9">Tanggal Transaksi</th>
                                    <th colspan="1">Options</th>
                                </tr>
                            </thead>
                            <tbody>
                                <% @transactions.each do |transaction| %>
                                <tr>
                                  <td><%= transaction.product.name %></td>
                                  <td><%= transaction.product.type_product %></td>
                                  <td><%= transaction.product.size %></td>
                                  <td><%= transaction.total %></td>
                                  <td><%= transaction.ppn %></td>
                                  <td><%= transaction.discount %></td>
                                  <td><%= transaction.total_price %></td>
                                  <td><%= transaction.created_at.strftime('%d-%m-%Y %H:%M') %></td>
                                  <td><%= link_to 'Destroy', transaction, method: :delete, data: { confirm: 'Are you sure?' } %></td>
                                </tr>
                              <% end %>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

app/views/transactions/new.html.erb
<%= render 'form' %>

<%= link_to 'Back', transactions_path %>

app/views/transactions/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Distributor:</strong>
  <%= @transaction.distributor_id %>
</p>

<p>
  <strong>Product:</strong>
  <%= @transaction.product_id %>
</p>

<p>
  <strong>Total:</strong>
  <%= @transaction.total %>
</p>

<%= link_to 'Edit', edit_transaction_path(@transaction) %> |
<%= link_to 'Back', transactions_path %>